Bug 1230183 - Package update does not work when package changes from noarch <-> arch
Package update does not work when package changes from noarch <-> arch
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: dnf (Show other bugs)
23
Unspecified Unspecified
low Severity unspecified
: ---
: ---
Assigned To: rpm-software-management
Fedora Extras Quality Assurance
: Regression, Reopened, Triaged
: 1341282 (view as bug list)
Depends On:
Blocks: 1036614
  Show dependency treegraph
 
Reported: 2015-06-10 08:12 EDT by Vít Ondruch
Modified: 2016-08-27 06:22 EDT (History)
10 users (show)

See Also:
Fixed In Version: dnf-1.1.10-1.fc24 dnf-1.1.10-1.fc23 dnf-1.1.10-1.fc25
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-08-19 15:51:48 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
rubygem-bson.spec (3.33 KB, text/plain)
2015-09-22 06:55 EDT, Vít Ondruch
no flags Details

  None (edit)
Description Vít Ondruch 2015-06-10 08:12:28 EDT
Description of problem:
rubygem-bson used to be noarch and the arch specific bits were shipped in separate rubygem-bson_ext package. Upstream now changed the way how they distribute the package and the rubygem-bson now ships always with the binary extension. This means that although rubygem-bson used to be noarch, it will be no architecure dependent. However, trying the update, dnf claims that rubygem-bson is not installed on my system although it is:

$ rpm -q rubygem-bson
rubygem-bson-1.10.2-1.fc21.noarch

# dnf update /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-1.10.2-2.fc23.x86_64.rpm 
Last metadata expiration check performed 0:37:11 ago on Wed Jun 10 13:26:45 2015.
Package rubygem-bson not installed, cannot update it.
Error: No packages marked for upgrade.

Interestingly, installation wants to do something, but I am not really sure what would be the result:


# dnf install /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-1.10.2-2.fc23.x86_64.rpm 
Last metadata expiration check performed 0:41:27 ago on Wed Jun 10 13:26:45 2015.
Dependencies resolved.
================================================================================
 Package            Arch         Version               Repository          Size
================================================================================
Upgrading:
 rubygem-bson       x86_64       1.10.2-2.fc23         @commandline        32 k

Transaction Summary
================================================================================
Upgrade  1 Package

Total size: 32 k
Is this ok [y/N]: 


Version-Release number of selected component (if applicable):
$ rpm -q dnf
dnf-1.0.0-1.fc22.noarch


How reproducible:
Always


Steps to Reproduce:
1.
2.
3.

Actual results:
When noarch package is update by arch package, the update does not work, claiming that the original package is not available.


Expected results:
Update from noarch to arch (and vice versa) should be possible.

Additional info:
Comment 1 Jan Kurik 2015-07-15 10:02:13 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23
Comment 2 Honza Silhan 2015-07-24 08:30:42 EDT
I am not sure what would Fedora packaging guideline say on this? Vit, how does yum handle it?
Comment 3 Vít Ondruch 2015-07-24 09:42:44 EDT
(In reply to Jan Silhan from comment #2)
> I am not sure what would Fedora packaging guideline say on this?

Do you have any specific concern? I don't see nothing against guidelines here.

> Vit, how does yum handle it?

I have no idea TBH.
Comment 4 Vít Ondruch 2015-09-22 04:58:21 EDT
Ping ... any chance to get this fixed and unblock rubygem-{bson,mongo,mongoid} update?


Just for the record, RPM itself updates the package just fine although it keeps rubygem-bson_ext behind:


# rpm -q rubygem-bson
rubygem-bson-1.10.2-2.fc23.noarch

# rpm -q rubygem-bson_ext
rubygem-bson_ext-1.10.2-4.fc23.x86_64

# rpm -Uvh /builddir/build/RPMS/rubygem-bson-3.0.4-1.fc24.x86_64.rpm 
warning: Generating 2 missing index(es), please wait...
Preparing...                          ################################# [100%]
Updating / installing...
   1:rubygem-bson-3.0.4-1.fc24        ################################# [ 50%]
Cleaning up / removing...
   2:rubygem-bson-1.10.2-2.fc23       ################################# [100%]

# rpm -q rubygem-bson
rubygem-bson-3.0.4-1.fc24.x86_64

# rpm -q rubygem-bson_ext
rubygem-bson_ext-1.10.2-4.fc23.x86_64
Comment 5 Vít Ondruch 2015-09-22 05:59:18 EDT
YUM handles the situation as well:


Yum command has been deprecated, use dnf instead.
See 'man dnf' and 'man yum2dnf' for more information.

Examining /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-3.0.4-1.fc24.x86_64.rpm: rubygem-bson-3.0.4-1.fc24.x86_64
Marking /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-3.0.4-1.fc24.x86_64.rpm as an update to rubygem-bson-1.10.2-2.fc23.noarch
Resolving Dependencies
--> Running transaction check
---> Package rubygem-bson.noarch 0:1.10.2-2.fc23 will be updated
---> Package rubygem-bson.x86_64 0:3.0.4-1.fc24 will be an update
--> Finished Dependency Resolution

Dependencies Resolved

================================================================================
 Package       Arch    Version         Repository                          Size
================================================================================
Updating:
 rubygem-bson  x86_64  3.0.4-1.fc24    /rubygem-bson-3.0.4-1.fc24.x86_64   99 k

Transaction Summary
================================================================================
Upgrade  1 Package

Total size: 99 k
Downloading packages:
Running transaction check
Running transaction test
Transaction test succeeded
Running transaction (shutdown inhibited)
  Updating   : rubygem-bson-3.0.4-1.fc24.x86_64                             1/2 
  Cleanup    : rubygem-bson-1.10.2-2.fc23.noarch                            2/2 
  Verifying  : rubygem-bson-3.0.4-1.fc24.x86_64                             1/2 
  Verifying  : rubygem-bson-1.10.2-2.fc23.noarch                            2/2 

Updated:
  rubygem-bson.x86_64 0:3.0.4-1.fc24                                            

Complete!
Comment 6 Vít Ondruch 2015-09-22 06:37:12 EDT
It even removes the bson_ext with correct obsoletes/provides:



Yum command has been deprecated, use dnf instead.
See 'man dnf' and 'man yum2dnf' for more information.

Examining /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-3.0.4-1.fc24.x86_64.rpm: rubygem-bson-3.0.4-1.fc24.x86_64
Marking /var/lib/mock/fedora-rawhide-x86_64/result/rubygem-bson-3.0.4-1.fc24.x86_64.rpm as an update to rubygem-bson-1.10.2-2.fc23.noarch
Resolving Dependencies
--> Running transaction check
---> Package rubygem-bson.noarch 0:1.10.2-2.fc23 will be updated
---> Package rubygem-bson.x86_64 0:3.0.4-1.fc24 will be obsoleting
---> Package rubygem-bson_ext.x86_64 0:1.10.2-4.fc23 will be obsoleted
--> Finished Dependency Resolution

Dependencies Resolved

================================================================================
 Package       Arch    Version         Repository                          Size
================================================================================
Installing:
 rubygem-bson  x86_64  3.0.4-1.fc24    /rubygem-bson-3.0.4-1.fc24.x86_64   99 k
     replacing  rubygem-bson_ext.x86_64 1.10.2-4.fc23

Transaction Summary
================================================================================
Install  1 Package

Total size: 99 k
Downloading packages:
Running transaction check
Running transaction test
Transaction test succeeded
Running transaction (shutdown inhibited)
  Installing : rubygem-bson-3.0.4-1.fc24.x86_64                             1/3 
  Erasing    : rubygem-bson_ext-1.10.2-4.fc23.x86_64                        2/3 
  Cleanup    : rubygem-bson-1.10.2-2.fc23.noarch                            3/3 
  Verifying  : rubygem-bson-3.0.4-1.fc24.x86_64                             1/3 
  Verifying  : rubygem-bson-1.10.2-2.fc23.noarch                            2/3 
  Verifying  : rubygem-bson_ext-1.10.2-4.fc23.x86_64                        3/3 

Installed:
  rubygem-bson.x86_64 0:3.0.4-1.fc24                                            

Replaced:
  rubygem-bson_ext.x86_64 0:1.10.2-4.fc23                                       

Complete!
Finish: run
Comment 7 Vít Ondruch 2015-09-22 06:40:08 EDT
No via RPM:


# rpm -q rubygem-bson  
rubygem-bson-1.10.2-2.fc23.noarch

# rpm -q rubygem-bson_ext
rubygem-bson_ext-1.10.2-4.fc23.x86_64

# rpm -Uvh /builddir/build/RPMS/rubygem-bson-3.0.4-1.fc24.x86_64.rpm 
warning: Generating 2 missing index(es), please wait...
Preparing...                          ################################# [100%]
Updating / installing...
   1:rubygem-bson-3.0.4-1.fc24        ################################# [ 33%]
Cleaning up / removing...
   2:rubygem-bson_ext-1.10.2-4.fc23   ################################# [ 67%]
   3:rubygem-bson-1.10.2-2.fc23       ################################# [100%]

# rpm -q rubygem-bson
rubygem-bson-3.0.4-1.fc24.x86_64

# rpm -q rubygem-bson_ext
package rubygem-bson_ext is not installed
Comment 8 Vít Ondruch 2015-09-22 06:55 EDT
Created attachment 1075768 [details]
rubygem-bson.spec

See the attached bson .spec file I am using for testing
Comment 9 Vít Ondruch 2016-04-07 07:24:46 EDT
Interesting, it seems that "dnf update" does not work, while "dnf install" updates the package just fine. But "install" is not the command one would use to update the system, right?
Comment 11 Igor Gnatenko 2016-06-06 05:43:25 EDT
*** Bug 1341282 has been marked as a duplicate of this bug. ***
Comment 12 Fedora Admin XMLRPC Client 2016-07-08 05:38:49 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 13 Igor Gnatenko 2016-07-21 11:54:08 EDT
Fixed as part of upcoming DNF 2.0 release.
Comment 14 Fedora Update System 2016-08-18 11:19:36 EDT
dnf-1.1.10-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-267f843cda
Comment 15 Fedora Update System 2016-08-18 11:20:48 EDT
dnf-1.1.10-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-8caa619a9e
Comment 16 Fedora Update System 2016-08-18 11:21:49 EDT
dnf-1.1.10-1.fc24 dnf-plugins-core-0.1.21-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-878284e0d3
Comment 17 Fedora Update System 2016-08-18 12:52:59 EDT
dnf-1.1.10-1.fc25, dnf-plugins-core-0.1.21-4.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-8caa619a9e
Comment 18 Fedora Update System 2016-08-18 20:22:45 EDT
dnf-1.1.10-1.fc23, dnf-plugins-core-0.1.21-3.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-267f843cda
Comment 19 Fedora Update System 2016-08-18 20:57:57 EDT
dnf-1.1.10-1.fc24, dnf-plugins-core-0.1.21-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-878284e0d3
Comment 20 Fedora Update System 2016-08-19 15:50:52 EDT
dnf-1.1.10-1.fc24, dnf-plugins-core-0.1.21-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 21 Fedora Update System 2016-08-23 11:19:59 EDT
dnf-1.1.10-1.fc23, dnf-plugins-core-0.1.21-3.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 22 Fedora Update System 2016-08-27 06:21:02 EDT
dnf-1.1.10-1.fc25, dnf-plugins-core-0.1.21-4.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.